import 'dart:async';
import 'package:amap_flutter_base/amap_flutter_base.dart';
import 'package:clx_map_poi_search/core/poi_result.dart';
import 'clx_map_poi_search_platform_interface.dart';

class ClxMapPoiSearch {

  /// 单例
  static ClxMapPoiSearch instance = ClxMapPoiSearch._();
  ClxMapPoiSearch._() {
    setupSearch();
  }

  // late final StreamController<MapEvent> mapEventStreamController;

  setupSearch() {
    // MethodChannel searchChannel = ClxMapPoiSearchPlatform.instance.getSearchChannel as MethodChannel;
    // searchChannel.setMethodCallHandler((call) => _handleMethodCall(call));
    // handleMethodCall的`broadcast`
    // mapEventStreamController = StreamController<MapEvent>.broadcast();
  }

  /// init Search
  initPoiSearch(AMapApiKey apiKey) {
    ClxMapPoiSearchPlatform.instance.initPoiSearch(apiKey);
  }

  /// Demo
  Future<String?> getPlatformVersion() {
    return ClxMapPoiSearchPlatform.instance.getPlatformVersion();
  }

  /// poi 搜索
  Future<PoiResult?> keywordsSearch(String keyWord) {
    return ClxMapPoiSearchPlatform.instance.keywordsSearch(keyWord);
  }

  /// 周边搜索
  Future<PoiResult?> aroundSearch(double latitude, double longitude) {
    return ClxMapPoiSearchPlatform.instance.aroundSearch(latitude, longitude);
  }

  // 回调函数
  // Future<dynamic> _handleMethodCall(MethodCall call) async {
  //   switch (call.method) {
  //     case 'camera#searchPOIEvent':
  //       try {
  //         mapEventStreamController.add(
  //           MapSearchPOIEvent(PoiResult.toPoiResult(call.arguments['searchPOIResult'])!),
  //         );
  //       } catch (e) {
  //         print("camera#searchPOIEvent error===>" + e.toString());
  //       }
  //       break;
  //   }
  // }
}
